using System;
using System.ComponentModel;
using System.Data;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Xml.Serialization;
using Microsoft.SharePoint;
using Microsoft.SharePoint.Utilities;
using Microsoft.SharePoint.WebPartPages;
using C1.Web.C1WebChart;

namespace C1WebPartSample
{
	public class C1WebChartSample : Microsoft.SharePoint.WebPartPages.WebPart
	{
		private C1WebChart chart = null;

		protected override void RenderWebPart(HtmlTextWriter output)
		{
			EnsureChildControls();
			CustomizeChart(chart);
			chart.RenderControl(output);
		}

		protected override void CreateChildControls()
		{
			// create a new chart
			base.CreateChildControls();
			chart = new C1WebChart();
			
			// use HttpHandler method, do not use session state
			chart.ImageRenderMethod = ImageRenderMethodEnum.HttpHandler;
			chart.ImageTransferMethod = ImageTransferMethodEnum.Cache;
			chart.ImageIdGeneration = ImageIdGenerationEnum.Unique;
			chart.ImageUri = "";

			// add the chart to this Web Part
			this.Controls.Add(chart);
		}

		private void CustomizeChart(C1WebChart chart)
		{
			try
			{
				DataSet ds = new DataSet();
				ds.ReadXml(Page.MapPath("/webparts_data/CategorySalesByQuarter.xml"));
				chart.LoadChartFromFile(Page.MapPath("/webparts_data/C1WebChartSample.chart2dxml"));
				chart.Width = Unit.Pixel(576);
				chart.Height = Unit.Pixel(424);
				chart.DataSource = ds.Tables[0];
				chart.DataBind();
			}
			catch (Exception e)
			{
				chart.Header.Text = e.Message;
				chart.Header.Visible = true;
			}
		}
	}
}
