using System;
using System.ComponentModel;
using System.Data;
using System.Xml;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Xml.Serialization;
using Microsoft.SharePoint;
using Microsoft.SharePoint.Utilities;
using Microsoft.SharePoint.WebPartPages;
using C1.Web.C1WebReport;

namespace C1WebPartSample
{
	public class C1WebReportSample : Microsoft.SharePoint.WebPartPages.WebPart
	{
		private C1WebReport report = null;

		protected override void RenderWebPart(HtmlTextWriter output)
		{
			EnsureChildControls();
			report.RenderControl(output);
		}

		protected override void CreateChildControls()
		{
			// create a new report viewer
			base.CreateChildControls();
			report = new C1WebReport();
			CustomizeReport(report);
			
			// add the report viewer to this Web Part
			this.Controls.Add(report);
		}

		private void CustomizeReport(C1WebReport report)
		{
			try
			{
				report.ImageRenderMethod = ImageRenderMethodEnum.HttpHandler;
				report.ReportSource.FileName = Page.MapPath("/webparts_data/C1WebReportSample.xml");
				report.ReportSource.ReportName = "Products by Category";
			}
			catch (Exception e)
			{
				report.NavigationBar.Text = e.Message;
				report.NavigationBar.Visible = true;
			}
		}
	}
}
