
function c1g_cb_init(id, divId, stateFieldId, groupedFieldId, pagerIdxFieldId)
{
	this.callback = null;
	this.action = "";
	this.gridId = id;
	this.gridDiv = c1g_getByName(divId);
	
	
	this.stateField = c1g_getByName(stateFieldId);
	this.getState = c1g_getStateField;
	this.setState = c1g_setStateField;
	
	this.groupedField = c1g_getByName(groupedFieldId);
	this.getGrouped = c1g_getGroupedField;
	this.setGrouped = c1g_setGroupedField; 
	this.updateGrouped = c1g_updateGroupedField;
	
	this.pagerIdxField = c1g_getByName(pagerIdxFieldId);
	this.getPagerIdx = c1g_getPagerIdxField;
	this.setPagerIdx = c1g_setPagerIdxField;
			
	this.clickedId = null;
}


function c1g_doCallback(sender, context, param)
{
	if (param == "GRP")
	{
		sender = c1g_upToTag(sender, "TR");
		if (!sender) return;

		var clientRowId = c1g_getattr(sender, "ID");
		var level = c1g_getNodeLevel(sender);
		if (level < 0) return;
 
		var table = c1g_upToTag(sender, "TABLE");
		if (!table) return;

		var expanding = true;
		if (sender.rowIndex + 1 < table.rows.length)
		{
			var tlevel = c1g_getNodeLevel(table.rows[sender.rowIndex + 1]);
			expanding = (tlevel <= level && tlevel != -1);
		}

		context.clickedId = clientRowId;
		var curGroupInfo = level + "~" + clientRowId
		context.updateGrouped(curGroupInfo);//^
		context.setState(curGroupInfo + "|" + context.getGrouped());//\/
	
		param = (expanding) ? "E" : "C";
 
		if (!expanding)
		{
			var i = sender.rowIndex + 1;
			while ((i < table.rows.length) && (table.rows[i].parentNode.tagName != "TFOOT"))
			{
				var tlevel = c1g_getNodeLevel(table.rows[i]);
				if (tlevel > level || tlevel == -1)
					table.deleteRow(i);
				else
					break;
			}
		}
		
		context.action = "GRP";
	}
	else
	{
		context.setState(context.getPagerIdx());
		context.action = "PGR";
	}

	context.callback(param);
}


function c1g_onCallback(result, context)
{
	if (result && result != "") // if we expanding group
    {
		if (context.action == "PGR")
		{
			var sep =  result.indexOf("|");
			var pgrIdx = result.substring(0, sep);
			context.setPagerIdx(pgrIdx);
			var res = result.substring(sep + 1, result.length);
			context.gridDiv.innerHTML = "";
			context.gridDiv.innerHTML = res;
			
			c1g_Props[context.gridId] = null;
			
			if (typeof(c1g_init) != "undefined")
				c1g_init(context.gridId, 0, 0);
				
			if (typeof(c1g_layout) != "undefined")
				c1g_layout(context.gridId, 0, 0);
		}
		else
		if (context.action == "GRP")
		{
			var row = document.getElementById(context.clickedId);
			var insertAt = row.rowIndex;

			var div = document.createElement("DIV");
			div.innerHTML = "<table>" + result + "</table>";
    
			var table = c1g_upToTag(row, "TABLE");
   
			var rows = div.firstChild.rows;
			for (var i = 0; i < rows.length; i++)
			{
				var newRow = table.insertRow(insertAt);
				c1g_copyRow(rows[i], newRow);
				insertAt++;
			}
		
			table.deleteRow(row.rowIndex);
		}
    }
}

function c1g_copyRow(from, to)
{
    c1g_copyAtrs(from, to);
    for (var i = 0; i < from.cells.length; i++)
    {
        var cell = to.insertCell(-1);
        c1g_copyAtrs(from.cells[i], cell);
        cell.innerHTML = from.cells[i].innerHTML;
    }
}

function c1g_copyAtrs(from, to)
{
	to.style.cssText = from.style.cssText;
	for (var i = 0; i < from.attributes.length; i++)
	{
		var value = from.attributes[i].nodeValue;

		if (from.attributes[i].specified && value != null)
			to.setAttribute(from.attributes[i].nodeName, value);
	}
}

function c1g_upToTag(item, tag)
{
    while (item && item.tagName != tag)
        item = c1g_getParent(item);
    
    return item;
}

/// hidden fields
function c1g_getStateField(arg)
{
	return arg + "|" + this.stateField.value;
}

function c1g_setStateField(value)
{
	this.stateField.value = value;
}

function c1g_getGroupedField()
{
	return this.groupedField.value;
}

function c1g_setGroupedField(value)
{
	this.groupedField.value = value;
}

function c1g_updateGroupedField(arg)
{
    var field = this.getGrouped();

    var vals = field.split(":");
    var res = "";
    
    var f = false;
    for (var i in vals)
        if (vals[i] && (vals[i] != ""))
            if (vals[i] != arg)
                res += vals[i] + ":";
            else
                f = true;
           
    if (!f)
        res += arg + ":";
    
    this.setGrouped(res);
}


function c1g_getPagerIdxField()
{
	return this.pagerIdxField.value;
}

function c1g_setPagerIdxField(value)
{
	this.pagerIdxField.value = value;
}
///

var cbObj = new Object();
function _c1g_doCallback(target, argument, cbEvent, context)
{
	var sendData = "C1WG_CB=" + target + "&C1WG_CBP=" + argument;
	sendData = formPostData + sendData; 
	
	if (navigator.userAgent.indexOf('MSIE') != -1)
	{
		var xmlRequest = new ActiveXObject("Microsoft.XMLHTTP");
		xmlRequest.onreadystatechange = _c1g_callbackComplete;
	
		cbObj.xmlRequest = xmlRequest;
		cbObj.cbEvent = cbEvent;
		cbObj.context = context;
	
		xmlRequest.open("POST", pageUrl, true);
		xmlRequest.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
		xmlRequest.send(sendData);
	}
	else
	{
		var xmlRequest = new XMLHttpRequest();
	
		xmlRequest.open("GET", pageUrl + "?" + sendData, false);
		xmlRequest.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
        xmlRequest.send(null);
        
        try
        {
			if (cbEvent)
				cbEvent(xmlRequest.responseText, context);
		}
		catch(e)
		{
			alert(e.message);
		}			
	}
}

function _c1g_callbackComplete()
{
	if (cbObj.xmlRequest.readyState == 4)
		if (cbObj.cbEvent)
			cbObj.cbEvent(cbObj.xmlRequest.responseText, cbObj.context); 
}

function _c1g_initCallback()
{
	var theForm = document.forms[0];

    count = theForm.elements.length;
    var element;
    re = new RegExp("\\x2B", "g");
    for (i = 0; i < count; i++)
    {
        element = theForm.elements[i];
        if (element.tagName.toLowerCase() == "input")
            formPostData += element.name + "=" + element.value.replace(re, "%2B") + "&";
        else
			if (element.tagName.toLowerCase() == "select")
			{
				selectCount = element.children.length;
				for (j = 0; j < selectCount; j++)
				{
					selectChild = element.children[j];
					if ((selectChild.tagName.toLowerCase() == "option") && (selectChild.selected == true))
						formPostData += element.name + "=" + selectChild.value.replace(re, "%2B") + "&";
				}
			}
    }
}