//
// Copyright (c) 2002 ComponentOne L.L.C. All rights reserved.
// Version 1.1.20024.1
//
function c1g_getNodeLevel(row)
{
	var node = c1g_getattr(row, "nodeLevel");
	return (node == null)? -1: parseInt(node);
}

function c1g_hasElementNode(item)
{
	var f = false;
	
	var len = item.childNodes.length;
	for (var i = 0; (i < len) && !f; i++)
		f = (item.childNodes[i].nodeType != 3);
		
	return f;
}

function c1g_getImgElement(row)
{
	var imgs = row.getElementsByTagName("IMG");
	return (imgs && imgs.length > 0) ? imgs[0] : null;
}


function c1g_ginit(gridid)
{
	var props = new Object();

	var grid = new c1g_getObj(gridid);
	props.split = (c1g_getattr(grid.obj, "Spliting") != null);
	
	c1g_Props[gridid] = props;
}

function c1g_toggleRowVisisbility(row, vis)
{
	if (row)
	{
		row.style.display = vis;
		
		var len = row.cells.length;		
		for (var i = 0; i < len; i++)
		{
			if (c1g_hasElementNode(row.cells[i]))
				row.cells[i].style.display = vis;
		}
	}
}


function c1g_showHide(e, groupby)
{
	if (!e) 
		e = window.event;
	
	// find row that was clicked
	var src = (e.srcElement) ? e.srcElement : e.currentTarget;
	var evtsrc = src;
  
	while (src && src.tagName != "TR")
		src = c1g_getParent(src);

	if (!src)
		 return;

	var imgExpanded = c1g_getattr(src, "expndimg");
	var imgCollapsed = c1g_getattr(src, "clpsimg");
	var clientRowID = c1g_getattr(src, "ID");	

	// get the node level
	var level = c1g_getNodeLevel(src);
	if (level < 0)
		 return;
	
	// loop through all rows below this one until the next node
	var table = c1g_getParent(src);
	while (table && table.tagName != "TABLE")
		table = c1g_getParent(table);
		
	if (!table)
		return;

	var rows = table.rows;
	var display = "";
	var lastlvl = true;
	var hdr = false;
	var len = rows.length;
	for (var row = src.rowIndex + 1; row < len; row++)
	{
		// stop at the next node higher than or equal to the source
		var rlevel = c1g_getNodeLevel(rows[row]);
		
		if (rlevel > -1 && rlevel <= level) break;
		if (c1g_getattr(rows[row], "pager") || c1g_getParent(rows[row]).tagName == "TFOOT") break;
		
		// handle detail rows

		if ((groupby && (level < rlevel || rlevel < 0)) || (!groupby && rlevel < 0))
		{
			// hiding or showing?
			if (display.length == 0)
				display = (rows[row].style.display == "none")? "": "none";
	
			// flip visibility
			if( groupby )
			{
				// if we're expanding only expand the next level up
				if( display == "" )
				{
					// group row
					//if( level <= rlevel )
					if (rlevel == level + 1 || !hdr || e.shiftKey)
					{
						hdr = (rlevel == level + 1);
						lastlvl = false;
						var img = c1g_getImgElement(rows[row]);
						if( rlevel > -1 && img && img.src)
							img.src = e.shiftKey ? c1g_getattr(rows[row], "expndimg") : c1g_getattr(rows[row], "clpsimg");
							
						c1g_toggleRowVisisbility(rows[row], display);
					}

					// datarow
					if (lastlvl && rlevel < 0 && !hdr)
						c1g_toggleRowVisisbility(rows[row], display);
				}
				else
				{
					if( level < rlevel )
					{
						var img = c1g_getImgElement(rows[row]);
						if(img && img.src )
							img.src = c1g_getattr(rows[row], "expndimg");
							
						c1g_toggleRowVisisbility(rows[row], display);
					}
					
					if (rlevel < 0)
						c1g_toggleRowVisisbility(rows[row], display);
				}
			}
			else
				if (rlevel < 0)
					c1g_toggleRowVisisbility(rows[row], display);
		}
	}

	// flip image
	src = evtsrc;
	if (src.tagName == "IMG")
		src.src = (display == "none")? imgCollapsed: imgExpanded;
		
	var gridid = c1g_getGridID(evtsrc);
	c1g_refreshGrid(gridid);

	var f = c1g_getByName("__"+gridid+"_GroupedRows");
	if (f)
	{
		var p = c1g_Props[gridid];
		clientRowID = level+"~"+clientRowID;
		
		if (f.value.indexOf(clientRowID) != -1)
			f.value = f.value.replace(clientRowID+":", "");
		else
			f.value += clientRowID+":";
	}
}