//
// Copyright (c) 2002 ComponentOne L.L.C. All rights reserved.
// Version 1.1.20024.1
//

function c1g_init(gridid)
{
  var props = new c1g_state();
  c1g_Props[gridid] = props;

  props.disabled = c1g_getattr(document.getElementById(gridid), "disabled");
  dragItem = new Object();
  c1g_dragItemReset();

  imgDown = document.getElementById(gridid + "_ImgColDn");
  imgUp = document.getElementById(gridid + "_ImgColUp");

  if (!props.disabled)
  {
    document.onmousedown = c1g_mouseDown;
    document.onmousemove = c1g_mouseMove;
    document.onmouseup = c1g_mouseUp;
  }
  datas[gridid] = new c1g_initDatas(gridid);

  if (!props.disabled)
    c1g_setCursor(gridid);
}


function c1g_initDatas(gridid)
{
  this.spliting = c1g_isSpliting(gridid);
	this.allowColMoving = c1g_isColMoving(gridid);
	this.groupCount = c1g_groupCount(gridid);

  var tmp = document.getElementById(gridid);
  this.gH = (tmp != null) ? tmp.tHead : null;

  tmp = c1g_getSubTable(gridid, 0, 0);
  this.th00 = (tmp != null) ? tmp.tHead : null;

  tmp = c1g_getSubTable(gridid, 0, 1);
  this.th01 = (tmp != null) ? tmp.tHead : null;

  tmp = c1g_getSubTable(gridid, 1, 0);
  this.th10 = (tmp != null) ? tmp.tHead : null;

  tmp = c1g_getSubTable(gridid, 1, 1);
  this.th11 = (tmp != null) ? tmp.tHead : null;
}


function c1g_mouseUp(e)
{
  if (dragItem.obj)
  {
    var idx = 0;
    var item = c1g_mouseInHeader(e, dragItem.gridid);

    if (item)
    {
      idx = c1g_getLogicalThIndex(dragItem.gridid, item);
      if (dragItem.colIdx != -1)
      {
        if (idx != dragItem.colIdx)
        {
          if ((dragItem.colIdx - 1 != idx) && (dragItem.colIdx + 1 != idx))
            if (idx < dragItem.colIdx)
            {
              if (dragItem.isLTR)
              {
                if (!(c1g_isLeft(e, item)))
                  idx++;
              }
              else
              {
                if (c1g_isLeft(e, item))
                  idx++;
              }
            }
            else
            {
              if (dragItem.isLTR)
              {
                if (c1g_isLeft(e, item))
                  idx--;
              }
              else
              {
                if (!(c1g_isLeft(e, item)))
                  idx--;
              }
            }

          __doPostBack(c1g_getUniqueID(dragItem.gridid), "ColMove:" + dragItem.colIdx + ":" + idx);
        }
      }
      else
      {
        if (dragItem.isLTR)
        {
          if (!(c1g_isLeft(e, item)))
            idx++;
        }
        else
        {
          if (c1g_isLeft(e, item))
            idx++;
        }

        __doPostBack(c1g_getUniqueID(dragItem.gridid), "GroupColMove:G:" + dragItem.grpIdx + ":C:" + idx);
      }
    }
    else
    {
      var gCount = datas[dragItem.gridid].groupCount;
      item = c1g_mouseInPanel(e, dragItem.gridid);
      if (item != -1 && ((dragItem.colIdx != -1 && c1g_canGroup(dragItem.src)) || dragItem.grpIdx != -1))
      {
        if (item == null)
        {
          if (dragItem.colIdx != -1)
            __doPostBack(c1g_getUniqueID(dragItem.gridid), "GroupColMove:C:" + dragItem.colIdx + ":G:" + gCount);
          else
            if (dragItem.grpIdx != gCount - 1)
              __doPostBack(c1g_getUniqueID(dragItem.gridid), "GroupColMove:G:" + dragItem.grpIdx + ":G:" + gCount);
        }
        else
        {
          idx = item.cellIndex;
          if (dragItem.colIdx != -1)
          {
            if (dragItem.isLTR)
            {
              if (!(c1g_isLeft(e, item)))
                idx++
            }
            else
            {
              if (c1g_isLeft(e, item))
                idx++
            }

            __doPostBack(c1g_getUniqueID(dragItem.gridid), "GroupColMove:C:" + dragItem.colIdx + ":G:" + idx);
          }
          else
            if (dragItem.grpIdx != item.cellIndex)
            {
              if ((dragItem.grpIdx - 1 !== item.cellIndex) && (dragItem.grpIdx + 1 != item.cellIndex))
                if (item.cellIndex < dragItem.grpIdx)
                {
                  if (dragItem.isLTR)
                  {
                    if (!(c1g_isLeft(e, item)))
                      idx++;
                  }
                  else
                  {
                    if (c1g_isLeft(e, item))
                      idx++;
                  }
                }
                else
                {
                  if (dragItem.isLTR)
                  {
                    if (c1g_isLeft(e, item))
                      idx--;
                  }
                  else
                  {
                    if (!(c1g_isLeft(e, item)))
                      idx--;
                  }
                }

              __doPostBack(c1g_getUniqueID(dragItem.gridid), "GroupColMove:G:" + dragItem.grpIdx + ":G:" + idx);
            }
        }
      }
      else
        if (c1g_mouseInGrid(e, dragItem.gridid) && (c1g_headersCnt(dragItem.gridid) == 0))
          __doPostBack(c1g_getUniqueID(dragItem.gridid), "GroupColMove:G:" + dragItem.grpIdx + ":C:0");
    }
  }

  c1g_disableDragItem();
  c1g_hideArrows();
}


function c1g_mouseMove(e)
{
  if (dragItem.obj)
  {
    dragItem.obj.style.visibility = "visible";

    var draw = false;
    var left = true;

    dragItem.obj.style.left = e.pageX - (parseInt(dragItem.obj.style.width) / 2);
    dragItem.obj.style.top = e.pageY - (parseInt(dragItem.obj.style.height) / 2);

    var item = c1g_mouseInHeader(e, dragItem.gridid);
    if (item)
    {
      var idx = c1g_getLogicalThIndex(dragItem.gridid, item);
      left = c1g_isLeft(e, item);
      draw = ((dragItem.grpIdx != -1) || ((dragItem.colIdx != -1) && (dragItem.colIdx != idx)));

      if (dragItem.colIdx != -1)
      {
        if (idx == dragItem.colIdx + 1)
          left = !(dragItem.isLTR);
        else
          if (idx == dragItem.colIdx - 1)
            left = dragItem.isLTR;
      }
    }
    else
    {
      var gCount = datas[dragItem.gridid].groupCount;
      item = c1g_mouseInPanel(e, dragItem.gridid);
      if (item != -1 && ((dragItem.colIdx != -1 && c1g_canGroup(dragItem.src)) || dragItem.grpIdx != -1))
      {
        if (item == null)
        {
          if (gCount > 0)
          {
            if ((dragItem.colIdx != -1) || (dragItem.grpIdx == -1) || (dragItem.grpIdx != gCount - 1))
            {
              item = document.getElementById(dragItem.gridid + "_GCOL_" + (gCount - 1));
              left = !dragItem.isLTR;
              draw = true;
            }
          }
          else
          {
            draw = true;
            item = document.getElementById(dragItem.gridid + "_Group");
            left = dragItem.isLTR;
          }
        }
        else
        {
          left = c1g_isLeft(e, item);
          draw = ((dragItem.colIdx != -1) || ((dragItem.grpIdx != -1) && (dragItem.grpIdx != item.cellIndex)));

          if (dragItem.grpIdx != -1)
          {
            if (item.cellIndex == dragItem.grpIdx + 1)
              left = !dragItem.isLTR;
            else
              if (item.cellIndex == dragItem.grpIdx - 1)
                left = dragItem.isLTR;
          }
        }
      }
      else
        if (c1g_mouseInGrid(e, dragItem.gridid) && (c1g_headersCnt(dragItem.gridid) == 0))
        {
          draw = true;
          if (!dragItem.isLTR)
            left = !left;
          item = document.getElementById(dragItem.gridid);
        }
    }
  }

  draw ? c1g_showArrows(item, left) : c1g_hideArrows();
}

function c1g_mouseDown(e)
{
  var item = e.target;
  var gridid = c1g_getGridID(item);

  if ((gridid) && c1g_isColMoving(gridid))
  {
    var hdr = c1g_mouseInHeader(e, gridid);

    if ((hdr) && (c1g_canMove(hdr)))
    {
      c1g_enableDragItem(hdr, gridid, e.pageX, e.pageY, true);
      return false;
    }
    else
    {
      hdr = c1g_mouseInPanel(e, gridid);
      if ((hdr != -1) && (hdr))
      {
        c1g_enableDragItem(hdr, gridid, e.pageX, e.pageY, false);
        return false;
      }
    }
  }

  return true;
}



//attributes stuff
function c1g_canGroup(elem)
{
  return (c1g_getattr(elem, "AllowGroup") == null);
}


function c1g_isColMoving(gridid)
{
	var g = document.getElementById(gridid);
	return (g) ? (c1g_getattr(g, "AllowColMoving") != null) : false;
}


function c1g_isSpliting(gridid)
{
  var g = document.getElementById(gridid);
  return (g) ? (c1g_getattr(g, "Spliting") != null) : false;
}


function c1g_canMove(elem)
{
  return (c1g_getattr(elem, "AllowMove") == null);
}


function c1g_groupCount(gridid)
{
  return c1g_getattr(document.getElementById(gridid), "GroupCount")
}




//headers stuff
function c1g_findThByCoords(thead, e)
{
  var res = null;

  if (thead != null && e != null)
  {
    var last = thead.rows.length - 1; //in case of pager
    var len = c1g_getThCnt(thead);
    for (var i = 0; ((i < len) && (!res)); i++)
    {
      var hdr = thead.rows[last].cells[i];
      var pX = c1g_findPosX(hdr);
      var pY = c1g_findPosY(hdr);

      if ((e.pageX > pX) && (e.pageX < pX + hdr.offsetWidth) && (e.pageY > pY) && (e.pageY < pY + hdr.offsetHeight))
        res = hdr;
    }
  }

  return res;
}


function c1g_foundTh(thead, th)
{
  var res = -1;

  if (thead && th)
  {
    var last = thead.rows.length - 1;
    var len = c1g_getThCnt(thead);

    for (var i = 0; ((i < len) && (res == -1)); i++)
      if (thead.rows[last].cells[i] == th)
        res = i;
  }

  return res;
}


function c1g_getThCnt(thead)
{
  return (thead != null) ? thead.rows[thead.rows.length - 1].cells.length : 0;
}


function c1g_getLogicalThIndex(gridid, th)
{
  var props = datas[gridid];
  var res = -1;

  if (!props.spliting)
    res = c1g_foundTh(props.gH, th);
  else
  {
    var a = props.th00;
    var b = props.th01;

    if (!a && !b)
    {
      a = props.th10;
      b = props.th11;
    }

    res = c1g_foundTh(a, th);

    if (res == -1)
    {
      res = c1g_foundTh(b, th);
      if ((res != -1) && (a))
        res += c1g_getThCnt(a);
    }
  }

  return res;
}


function c1g_headersCnt(gridid)
{
  var  props = datas[gridid];
  if (!props.spliting)
    return c1g_getThCnt(props.gH);
  else
    return c1g_getThCnt(props.th00) + c1g_getThCnt(props.th01) + c1g_getThCnt(props.th10) + c1g_getThCnt(props.th11);
}




//cursor stuff
function c1g_setCursor(gridid)
{
  document.getElementById(gridid).style.cursor = "default";		

  if (datas[gridid].allowColMoving)
  {
    var gCount = datas[gridid].groupCount;
    for (var i = 0; i < gCount; i++)
      document.getElementById(gridid + "_GCOL_" + i).style.cursor = "pointer";

    if (!datas[gridid].spliting)
      c1g_setTHeadCursor(datas[gridid].gH);
    else
    {
      c1g_setTHeadCursor(datas[gridid].th00);
      c1g_setTHeadCursor(datas[gridid].th01);
      c1g_setTHeadCursor(datas[gridid].th10);
      c1g_setTHeadCursor(datas[gridid].th11);
    }   	
  }
}


function c1g_setTHeadCursor(thead)
{
  if (thead && thead.rows)
  {
    var last = thead.rows.length - 1;
    for (var i = 0; i < c1g_getThCnt(thead); i++)
      thead.rows[last].cells[i].style.cursor = "pointer";
  }
}




//common stuff
function c1g_findPosX(elem)
{
  var res = 0;

  if (elem)
  do
  {
    res += elem.offsetLeft + (elem.border == undefined ? 0 : parseInt(elem.border));
    elem = elem.offsetParent;
  }
  while (elem != null);

  return res;
}


function c1g_findPosY(elem)
{
  var res = 0;

  if (elem)
  do
  {
    res += elem.offsetTop + (elem.border == undefined ? 0 : parseInt(elem.border));
    elem = elem.offsetParent;
  }
  while (elem != null);

  return res;
}


function c1g_isLeft(e, item)
{
  return (e.pageX < c1g_findPosX(item) + (item.offsetWidth / 2));
}


function c1g_mouseInGrid(e, gridid)
{
  var grid = document.getElementById(gridid);
  if (grid)
  {
    var pX = c1g_findPosX(grid);
    var pY = c1g_findPosY(grid);

    if ((e.pageX > pX) && (e.pageX < pX + grid.offsetWidth) && (e.pageY > pY) && (e.pageY < pY + grid.offsetHeight))
      return true;
  }

  return false;
}


function c1g_mouseInHeader(e, gridid)
{
  var props = datas[gridid];
  var res = null;

  if (!props.spliting)
    res = c1g_findThByCoords(props.gH, e);
  else
  {
    var a = props.th00;
    var b = props.th01;

    if (!a && !b)
    {
      a = props.th10;
      b = props.th11;
    }

    res = c1g_findThByCoords(a, e);

    if (!res)
      res = c1g_findThByCoords(b, e);
  }

  return res;
}


//<item> = over the item
//null = over the panel
//else = -1
function c1g_mouseInPanel(e, gridid)
{
  var panel = document.getElementById(gridid + "_Group");

  if (panel)
  {
    var pX = c1g_findPosX(panel);
    var pY = c1g_findPosY(panel);

    if ((e.pageX > pX) && (e.pageX < pX + panel.offsetWidth) && (e.pageY > pY) && (e.pageY < pY + panel.offsetHeight))
    {
			var gCount =  datas[gridid].groupCount;
      for (var i = 0; i < gCount; i++)
      {
        var item = document.getElementById(gridid + "_GCOL_" + i);
        pX = c1g_findPosX(item);
        pY = c1g_findPosY(item);

        if ((e.pageX > pX) && (e.pageX < pX + item.offsetWidth) && (e.pageY > pY) && (e.pageY < pY + item.offsetHeight))
          return item;
      }
      return null;
    }
  }

  return -1;
}




//DragItem stuff
function c1g_disableDragItem()
{
  if (dragItem.obj)
  {
    dragItem.obj.style.visibility = "hidden";
    c1g_dragItemReset();
  }
}


function c1g_dragItemReset()
{
  dragItem.obj = null;
  dragItem.colIdx = -1;
  dragItem.grpIdx = -1;
  dragItem.gridid = "";
  dragItem.isLTR = true;
  dragItem.src = null;
}


function c1g_enableDragItem(hdr, gridid, x, y, ishdr)
{
  try
  {
    dragItem.obj = document.getElementById("~~dragElem");
    dragItem.isLTR = c1g_isLTR(gridid);

    var o = hdr;
    while (o.firstChild != null)
      o = o.firstChild;

    dragItem.src = hdr;
    dragItem.obj.innerHTML = (typeof(o.innerHTML) == "undefined") ? o.nodeValue : o.innerHTML;
    dragItem.obj.style.width = hdr.offsetWidth - 5;
    dragItem.obj.style.height = hdr.offsetHeight - 5;
    dragItem.obj.style.left = x - (parseInt(dragItem.obj.style.width) / 2);;
    dragItem.obj.style.top = y - (parseInt(dragItem.obj.style.height) / 2);;

	while (o.parentNode)
		if ((typeof(o.bgColor) != "undefined" && o.bgColor != "") ||
			(typeof(o.style) != "undefined" && (o.style.color != "" || o.style.backgroundColor != "")))
			break;
		else
			o = o.parentNode;
	
	if (o)
	{
		if (typeof(o.bgColor) != "undefined" && o.bgColor != "")
			dragItem.obj.style.backgroundColor = o.bgColor;
		else
		if (typeof(o.style) != "undefined")
		{
			dragItem.obj.style.color = o.style.color;
			dragItem.obj.style.backgroundColor = o.style.backgroundColor;
		}
	}
  
    if (ishdr)
      dragItem.colIdx = c1g_getLogicalThIndex(gridid, hdr);
    else
      dragItem.grpIdx = hdr.cellIndex;

    dragItem.gridid = gridid;
  }
  catch(e)
  {
    c1g_dragItemReset();
  }
}


function c1g_hideArrows()
{
  if (imgUp)
    imgUp.style.visibility = "hidden";

  if (imgDown)
    imgDown.style.visibility = "hidden";
}

function c1g_showArrows(hdr, left)
{
  if (hdr)
  {
    var pX = c1g_findPosX(hdr);
    var pY = c1g_findPosY(hdr);

    if (left)
    {
      imgDown.style.left = pX - (imgDown.width/ 2);
      imgDown.style.top = pY - imgDown.height;
      imgUp.style.left = pX - (imgDown.width/ 2);
      imgUp.style.top = pY + hdr.offsetHeight;
    }
    else
    {
      imgDown.style.left = pX + hdr.offsetWidth - (imgDown.width/ 2);
      imgDown.style.top = pY  - imgDown.height;
      imgUp.style.left = pX + hdr.offsetWidth - (imgDown.width/ 2);
      imgUp.style.top = pY + hdr.offsetHeight;
    }

    imgUp.style.visibility = "visible";
    imgDown.style.visibility = "visible";
  }
}


var dragItem = null;
var imgDown = null;
var imgUp = null;
var datas = [];

document.writeln('<div id="~~dragElem" align="CENTER" style="cursor:default;position:absolute;overflow:hidden;visibility:hidden;border-color:#6495ED;border-width:2px;border-style:Solid;font-family:Arial;font-size:10pt;font-weight:bold;z-index:10000;"></div>');